package rpgEngine.Resources;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Dictionary;
import java.util.Hashtable;


public class LevelRequirementPool {
	private static LevelRequirementPool instance;
	private Dictionary<Integer,Integer> items;
	
	private LevelRequirementPool() {
		items = new Hashtable<Integer,Integer>();
		loadData();
	}
	
	
	public static LevelRequirementPool getInstance() {
		if(instance == null) {
			instance = new LevelRequirementPool();
		}
		
		return instance;
	}
	
	
	public Integer getPoolItem(Integer i) {
		Integer item = null;
		
		try 
		{
			item = items.get(i);	
		}
		catch(Exception e) 
		{
			return null;	
		}
		
		return item;
	}
	
	
	private void loadData() {	
		String filename = "levelRequirements.cfg";
		String[] columns = null;
		InputStream fileStream = null;
		BufferedReader reader = null;
		String line = "";
		Integer req = null;
		
		//Open File
		try {
			fileStream = this.getClass().getResourceAsStream("Config/" + filename);
			reader = new BufferedReader(new InputStreamReader(fileStream));
		}
		catch(Exception e) {
			System.err.println("Error openning file" + filename);
			System.err.println(e.toString());
			return;
		}
		
		//Read File
		try {
			while(reader.ready()) {
				line = reader.readLine();
				
				columns = line.split(",");
				
				if(columns[0].equals("Level") == false) {
					req = Integer.parseInt(columns[1]);
					
					items.put(Integer.parseInt(columns[0]),req);
				}
			}
		}
		catch(Exception e) {
			System.err.println("Error reading file" + filename);
			System.err.println(e.toString());
			return;
		}
		
		//Close File
		try {
			reader.close();
			fileStream.close();
		}
		catch(Exception e) {
			System.err.println("Error closing file" + filename);
			System.err.println(e.toString());
			return;
		}
	}
}
